module Doable
  module Exceptions
    # Exceptions which are agnostic to the underlying OS.
    module OS
      # Generic exception to be inherited by all other OS-level exceptions.
      class OSException < GenericFrameworkError
      end

      class WrongUser < OSException
      end

      class MissingDirectory < OSException
      end

      class DirectoryExists < OSException
      end

      class InvalidHostname < OSException
      end

      class FailedPasswordChange < OSException
      end

      class MissingFile < OSException
      end

      class MissingExecutable < OSException
      end

      class FailedCopy < OSException
      end

      class NotApplicable < OSException
      end

      class DuplicateUsers < OSException
      end

      class DuplicateGroups < OSException
      end

      class WrongHomedir < OSException
      end

      class InvalidArchitecture < OSException
      end

      class MissingUser < OSException
      end

      class WrongUser < OSException
      end

      class FailedGroupAdd < OSException
      end

      class FailedUserModification < OSException
      end

      class FailedUncompress < OSException
      end

      class AmbiguousProcess < OSException
      end
    end
  end
end
